// js 导入 模块式开发

import Vue from "vue";
// 导入 App.vue
import App from "./App.vue";
// import zujian from "./components/zujian.vue"
import HelloWorld from "./components/HelloWorld.vue";
import aaa from "./components/aaa.vue";
import VueRouter from "vue-router";
import index from "./pages/index.vue";
import ElementUI from "element-ui";
import "element-ui/lib/theme-chalk/index.css";

// vuerouter 插件
Vue.use(ElementUI);
Vue.use(VueRouter);
// 路径 => 页面(组件)
const routes = [
  {
    path: "/abc",
    component: HelloWorld,
    meta: "u",
  },
  {
    path: "/agfahg",
    component: aaa,
    meta: "u",
  },
  {
    path: "/",
    component: index,
    meta: "m",
  },
  {
    path: "/login",
    component: () => import("./components/luyou.vue"),
    children: [
      {
        path: "user",
        component: () => import("./pages/user.vue"),
        beforeEnter: (to, from, next) => {
          // ...
          next();
          console.log("路由独享守卫");
        },
      },
      {
        path: "abc",
        component: HelloWorld,
      },
    ],
  },
];

const router = new VueRouter({
  mode: "history",
  routes, // (缩写) 相当于 routes: routes
});

router.beforeEach((to, from, next) => {
  //全局前置守卫
  /*   console.log(to); //到哪里去
  console.log(from); //上个页面  从哪里来的 */

  console.log("这是导航守卫");
  if (to.path != "/login/user") {
    console.log("执行next");
    next(); //控制页面跳转
  } else {
    alert("不能打开");
  }
});
router.beforeResolve((to, from, next) => {
  // ...全局解析守卫
  next();
});

router.afterEach(() => {
  console.log("跳转完成");
  // ...全局后置钩子
});

Vue.config.productionTip = true;

new Vue({
  render: (h) => h(App),
  router,
}).$mount("#aaa");
